"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createCritical = exports.getCritical = exports.isCritical = exports.serializeError = exports.mixUrl = void 0;
var types_1 = require("./types");
var mixUrl = function (props) {
    var href = globalThis && globalThis.location && globalThis.location.href ? globalThis.location.href : '';
    return Object.assign({}, href !== '' ? { url: href } : {}, props);
};
exports.mixUrl = mixUrl;
var serializeError = function (stack, lineNumber) {
    var alt = {
        stack: [],
        message: '',
        line: lineNumber
    };
    Object.getOwnPropertyNames(stack).forEach(function (key) {
        if (key === 'stack') {
            alt[key] = stack[key].split('\n');
        }
        else {
            alt[key] = stack[key];
        }
    }, stack);
    return alt;
};
exports.serializeError = serializeError;
var CRITICAL = 'critical';
var isCritical = function (type) { return CRITICAL === type; };
exports.isCritical = isCritical;
var getCritical = function () { return CRITICAL; };
exports.getCritical = getCritical;
var createCritical = function (trace, lineNumber) {
    var _a;
    var criticalError = (0, exports.serializeError)(trace, lineNumber);
    return _a = {},
        _a[CRITICAL] = (0, exports.mixUrl)(criticalError),
        _a;
};
exports.createCritical = createCritical;
