"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var logger_1 = require("./logger");
var logger;
beforeAll(function () {
    logger = (0, logger_1.createLogger)();
    logger.setUp({
        active: true
    });
});
describe('Test active logger', function () {
    ['log', 'info', 'debug', 'warn', 'error'].forEach(function (logMethod, index) {
        test("Logger test ".concat(logMethod, " method"), function () {
            var _a;
            logger[logMethod]("test ".concat(logMethod, " method"));
            var logItem = logger.getStackCollection().getData()[index];
            expect(Object.keys(logItem)[0])
                .toBe(logMethod);
            expect(logItem)
                .toStrictEqual((_a = {}, _a[logMethod] = "test ".concat(logMethod, " method"), _a));
        });
    });
});
describe('Test no-active logger', function () {
    test('Logger test all methods', function () {
        logger.setUp({
            active: false
        });
        var stackLengthBefore = logger.getStackCollection().getData().length;
        ['log', 'info', 'debug', 'warn', 'error'].forEach(function (logMethod) {
            logger[logMethod]("test ".concat(logMethod, " method"));
        });
        var stackLengthAfter = logger.getStackCollection().getData().length;
        expect(stackLengthBefore)
            .toBe(stackLengthAfter);
    });
});
